import trimEnd from 'string.prototype.trimend';
import vscodeOniguruma from 'vscode-oniguruma';
import vscodeTextmate from 'vscode-textmate';

const loadGrammarFile = (scope) => {
    switch (scope) {
        case "documentation.injection.js.jsx":
            return import('./extensions-typescript-basics-syntaxes-jsdoc.js.injection.tmLanguage-e8d7a4a1.js').then((m) => m.default);
        case "documentation.injection.ts":
            return import('./extensions-typescript-basics-syntaxes-jsdoc.ts.injection.tmLanguage-bce043e2.js').then((m) => m.default);
        case "markdown.math.block":
            return import('./extensions-markdown-math-syntaxes-md-math-block.tmLanguage-35e9a826.js').then((m) => m.default);
        case "markdown.math.inline":
            return import('./extensions-markdown-math-syntaxes-md-math-inline.tmLanguage-046f2835.js').then((m) => m.default);
        case "source.batchfile":
            return import('./extensions-bat-syntaxes-batchfile.tmLanguage-00039806.js').then((m) => m.default);
        case "source.c":
            return import('./extensions-cpp-syntaxes-c.tmLanguage-3a0be9ef.js').then((m) => m.default);
        case "source.c.platform":
            return import('./extensions-cpp-syntaxes-platform.tmLanguage-827ec892.js').then((m) => m.default);
        case "source.clojure":
            return import('./extensions-clojure-syntaxes-clojure.tmLanguage-8a6653df.js').then((m) => m.default);
        case "source.coffee":
            return import('./extensions-coffeescript-syntaxes-coffeescript.tmLanguage-4462ffbe.js').then((m) => m.default);
        case "source.cpp":
            return import('./extensions-cpp-syntaxes-cpp.tmLanguage-b8b1a433.js').then((m) => m.default);
        case "source.cpp.embedded.latex":
            return import('./extensions-latex-syntaxes-cpp-grammar-bailout.tmLanguage-2a290b09.js').then((m) => m.default);
        case "source.cpp.embedded.macro":
            return import('./extensions-cpp-syntaxes-cpp.embedded.macro.tmLanguage-81680e0e.js').then((m) => m.default);
        case "source.cs":
            return import('./extensions-csharp-syntaxes-csharp.tmLanguage-caecf9a2.js').then((m) => m.default);
        case "source.css":
            return import('./extensions-css-syntaxes-css.tmLanguage-c4221589.js').then((m) => m.default);
        case "source.css.less":
            return import('./extensions-less-syntaxes-less.tmLanguage-646ed17c.js').then((m) => m.default);
        case "source.css.scss":
            return import('./extensions-scss-syntaxes-scss.tmLanguage-b0c0462e.js').then((m) => m.default);
        case "source.cuda-cpp":
            return import('./extensions-cpp-syntaxes-cuda-cpp.tmLanguage-fd8b8013.js').then((m) => m.default);
        case "source.dart":
            return import('./extensions-dart-syntaxes-dart.tmLanguage-9ed11c46.js').then((m) => m.default);
        case "source.diff":
            return import('./extensions-diff-syntaxes-diff.tmLanguage-15d03327.js').then((m) => m.default);
        case "source.dockerfile":
            return import('./extensions-docker-syntaxes-docker.tmLanguage-2892ec3e.js').then((m) => m.default);
        case "source.fsharp":
            return import('./extensions-fsharp-syntaxes-fsharp.tmLanguage-14460439.js').then((m) => m.default);
        case "source.go":
            return import('./extensions-go-syntaxes-go.tmLanguage-d6a7ddb0.js').then((m) => m.default);
        case "source.groovy":
            return import('./extensions-groovy-syntaxes-groovy.tmLanguage-31b1a108.js').then((m) => m.default);
        case "source.hlsl":
            return import('./extensions-hlsl-syntaxes-hlsl.tmLanguage-56eb2e29.js').then((m) => m.default);
        case "source.ignore":
            return import('./extensions-git-base-syntaxes-ignore.tmLanguage-6afbbae8.js').then((m) => m.default);
        case "source.ini":
            return import('./extensions-ini-syntaxes-ini.tmLanguage-b2544ea5.js').then((m) => m.default);
        case "source.java":
            return import('./extensions-java-syntaxes-java.tmLanguage-168083d6.js').then((m) => m.default);
        case "source.js":
            return import('./extensions-javascript-syntaxes-JavaScript.tmLanguage-ecadf520.js').then((m) => m.default);
        case "source.js.jsx":
            return import('./extensions-javascript-syntaxes-JavaScriptReact.tmLanguage-c7127d30.js').then((m) => m.default);
        case "source.json":
            return import('./extensions-json-syntaxes-JSON.tmLanguage-3ea7e017.js').then((m) => m.default);
        case "source.json.comments":
            return import('./extensions-json-syntaxes-JSONC.tmLanguage-726a9867.js').then((m) => m.default);
        case "source.jsonnet":
            return import('./jsonnet.tmLanguage-ba22f547.js').then((m) => m.default);
        case "source.julia":
            return import('./extensions-julia-syntaxes-julia.tmLanguage-da8a9420.js').then((m) => m.default);
        case "source.lua":
            return import('./extensions-lua-syntaxes-lua.tmLanguage-066f3aeb.js').then((m) => m.default);
        case "source.makefile":
            return import('./extensions-make-syntaxes-make.tmLanguage-9fcdfb54.js').then((m) => m.default);
        case "source.objc":
            return import('./extensions-objective-c-syntaxes-objective-c.tmLanguage-3de21ff8.js').then((m) => m.default);
        case "source.objcpp":
            return import('./extensions-objective-c-syntaxes-objective-c__.tmLanguage-e28a5163.js').then((m) => m.default);
        case "source.perl":
            return import('./extensions-perl-syntaxes-perl.tmLanguage-e1adf2ff.js').then((m) => m.default);
        case "source.perl.6":
            return import('./extensions-perl-syntaxes-perl6.tmLanguage-62bad40f.js').then((m) => m.default);
        case "source.php":
            return import('./extensions-php-syntaxes-php.tmLanguage-4c3036d1.js').then((m) => m.default);
        case "source.powershell":
            return import('./extensions-powershell-syntaxes-powershell.tmLanguage-8141af18.js').then((m) => m.default);
        case "source.python":
            return import('./extensions-python-syntaxes-MagicPython.tmLanguage-7605ef87.js').then((m) => m.default);
        case "source.r":
            return import('./extensions-r-syntaxes-r.tmLanguage-48ab00e7.js').then((m) => m.default);
        case "source.regexp.python":
            return import('./extensions-python-syntaxes-MagicRegExp.tmLanguage-033bf903.js').then((m) => m.default);
        case "source.rst":
            return import('./extensions-restructuredtext-syntaxes-rst.tmLanguage-165cc97c.js').then((m) => m.default);
        case "source.ruby":
            return import('./extensions-ruby-syntaxes-ruby.tmLanguage-14be7b24.js').then((m) => m.default);
        case "source.rust":
            return import('./extensions-rust-syntaxes-rust.tmLanguage-8a9dafe8.js').then((m) => m.default);
        case "source.sassdoc":
            return import('./extensions-scss-syntaxes-sassdoc.tmLanguage-318b3f65.js').then((m) => m.default);
        case "source.shaderlab":
            return import('./extensions-shaderlab-syntaxes-shaderlab.tmLanguage-477c8cda.js').then((m) => m.default);
        case "source.shell":
            return import('./extensions-shellscript-syntaxes-shell-unix-bash.tmLanguage-faed202f.js').then((m) => m.default);
        case "source.sql":
            return import('./extensions-sql-syntaxes-sql.tmLanguage-1da710bd.js').then((m) => m.default);
        case "source.swift":
            return import('./extensions-swift-syntaxes-swift.tmLanguage-ddfd89a4.js').then((m) => m.default);
        case "source.ts":
            return import('./extensions-typescript-basics-syntaxes-TypeScript.tmLanguage-cecc4704.js').then((m) => m.default);
        case "source.tsx":
            return import('./extensions-typescript-basics-syntaxes-TypeScriptReact.tmLanguage-75e09d45.js').then((m) => m.default);
        case "source.yaml":
            return import('./extensions-yaml-syntaxes-yaml.tmLanguage-057b7fe8.js').then((m) => m.default);
        case "text.bibtex":
            return import('./extensions-latex-syntaxes-Bibtex.tmLanguage-4f1fa17e.js').then((m) => m.default);
        case "text.git-commit":
            return import('./extensions-git-base-syntaxes-git-commit.tmLanguage-3c6e7056.js').then((m) => m.default);
        case "text.git-rebase":
            return import('./extensions-git-base-syntaxes-git-rebase.tmLanguage-6a25cc3b.js').then((m) => m.default);
        case "text.html.basic":
            return import('./extensions-html-syntaxes-html.tmLanguage-42604ccb.js').then((m) => m.default);
        case "text.html.cshtml":
            return import('./extensions-razor-syntaxes-cshtml.tmLanguage-1f02fee4.js').then((m) => m.default);
        case "text.html.derivative":
            return import('./extensions-html-syntaxes-html-derivative.tmLanguage-d73cadc1.js').then((m) => m.default);
        case "text.html.handlebars":
            return import('./extensions-handlebars-syntaxes-Handlebars.tmLanguage-c3056612.js').then((m) => m.default);
        case "text.html.markdown":
            return import('./extensions-markdown-basics-syntaxes-markdown.tmLanguage-708fe5ad.js').then((m) => m.default);
        case "text.html.markdown.math":
            return import('./extensions-markdown-math-syntaxes-md-math.tmLanguage-1934ac66.js').then((m) => m.default);
        case "text.html.php":
            return import('./extensions-php-syntaxes-html.tmLanguage-a6fc247a.js').then((m) => m.default);
        case "text.log":
            return import('./extensions-log-syntaxes-log.tmLanguage-27723326.js').then((m) => m.default);
        case "text.pug":
            return import('./extensions-pug-syntaxes-pug.tmLanguage-bfe2bfad.js').then((m) => m.default);
        case "text.searchResult":
            return import('./extensions-search-result-syntaxes-searchResult.tmLanguage-1d9e75e1.js').then((m) => m.default);
        case "text.tex":
            return import('./extensions-latex-syntaxes-TeX.tmLanguage-627f5ce0.js').then((m) => m.default);
        case "text.tex.latex":
            return import('./extensions-latex-syntaxes-LaTeX.tmLanguage-b55ac743.js').then((m) => m.default);
        case "text.tex.markdown_latex_combined":
            return import('./extensions-latex-syntaxes-markdown-latex-combined.tmLanguage-12363f19.js').then((m) => m.default);
        case "text.xml":
            return import('./extensions-xml-syntaxes-xml.tmLanguage-35bc4530.js').then((m) => m.default);
        case "text.xml.xsl":
            return import('./extensions-xml-syntaxes-xsl.tmLanguage-f8511a02.js').then((m) => m.default);
        default:
            return Promise.resolve(null);
    }
};
const getLang = (lang) => {
    switch (lang) {
        case "documentation.injection.js.jsx":
            return "documentation.injection.js.jsx";
        case "documentation.injection.ts":
            return "documentation.injection.ts";
        case "markdown.math.block":
            return "markdown.math.block";
        case "markdown.math.inline":
            return "markdown.math.inline";
        case "source.batchfile":
            return "source.batchfile";
        case "source.c":
            return "source.c";
        case "source.c.platform":
            return "source.c.platform";
        case "source.clojure":
            return "source.clojure";
        case "source.coffee":
            return "source.coffee";
        case "source.cpp":
            return "source.cpp";
        case "source.cpp.embedded.latex":
            return "source.cpp.embedded.latex";
        case "source.cpp.embedded.macro":
            return "source.cpp.embedded.macro";
        case "source.cs":
            return "source.cs";
        case "c#":
            return "source.cs";
        case "csharp":
            return "source.cs";
        case "dotnet":
            return "source.cs";
        case "source.css":
            return "source.css";
        case "source.css.less":
            return "source.css.less";
        case "source.css.scss":
            return "source.css.scss";
        case "source.cuda-cpp":
            return "source.cuda-cpp";
        case "source.dart":
            return "source.dart";
        case "source.diff":
            return "source.diff";
        case "source.dockerfile":
            return "source.dockerfile";
        case "source.fsharp":
            return "source.fsharp";
        case "fsharp":
            return "source.fsharp";
        case "fsx":
            return "source.fsharp";
        case "fs":
            return "source.fsharp";
        case "source.go":
            return "source.go";
        case "source.groovy":
            return "source.groovy";
        case "source.hlsl":
            return "source.hlsl";
        case "source.ignore":
            return "source.ignore";
        case "source.ini":
            return "source.ini";
        case "source.java":
            return "source.java";
        case "source.js":
            return "source.js";
        case "source.js.jsx":
            return "source.js.jsx";
        case "source.json":
            return "source.json";
        case "json":
            return "source.json";
        case "source.json.comments":
            return "source.json.comments";
        case "source.jsonnet":
            return "source.jsonnet";
        case "jsonnet":
            return "source.jsonnet";
        case "libjsonnet":
            return "source.jsonnet";
        case "source.julia":
            return "source.julia";
        case "source.lua":
            return "source.lua";
        case "source.makefile":
            return "source.makefile";
        case "source.objc":
            return "source.objc";
        case "source.objcpp":
            return "source.objcpp";
        case "source.perl":
            return "source.perl";
        case "source.perl.6":
            return "source.perl.6";
        case "source.php":
            return "source.php";
        case "source.powershell":
            return "source.powershell";
        case "source.python":
            return "source.python";
        case "source.r":
            return "source.r";
        case "source.regexp.python":
            return "source.regexp.python";
        case "source.rst":
            return "source.rst";
        case "source.ruby":
            return "source.ruby";
        case "source.rust":
            return "source.rust";
        case "rust":
            return "source.rust";
        case "source.sassdoc":
            return "source.sassdoc";
        case "source.shaderlab":
            return "source.shaderlab";
        case "source.shell":
            return "source.shell";
        case "source.sql":
            return "source.sql";
        case "source.swift":
            return "source.swift";
        case "source.ts":
            return "source.ts";
        case "source.tsx":
            return "source.tsx";
        case "source.yaml":
            return "source.yaml";
        case "text.bibtex":
            return "text.bibtex";
        case "text.git-commit":
            return "text.git-commit";
        case "text.git-rebase":
            return "text.git-rebase";
        case "text.html.basic":
            return "text.html.basic";
        case "text.html.cshtml":
            return "text.html.cshtml";
        case "text.html.derivative":
            return "text.html.derivative";
        case "text.html.handlebars":
            return "text.html.handlebars";
        case "text.html.markdown":
            return "text.html.markdown";
        case "markdown":
            return "text.html.markdown";
        case "md":
            return "text.html.markdown";
        case "text.html.markdown.math":
            return "text.html.markdown.math";
        case "text.html.php":
            return "text.html.php";
        case "text.log":
            return "text.log";
        case "text.pug":
            return "text.pug";
        case "text.searchResult":
            return "text.searchResult";
        case "text.tex":
            return "text.tex";
        case "text.tex.latex":
            return "text.tex.latex";
        case "text.tex.markdown_latex_combined":
            return "text.tex.markdown_latex_combined";
        case "text.xml":
            return "text.xml";
        case "text.xml.xsl":
            return "text.xml.xsl";
        default:
            return null;
    }
};

const { INITIAL, Registry, parseRawGrammar } = vscodeTextmate;
const { OnigScanner, OnigString, loadWASM } = vscodeOniguruma;
const loadGrammar = async (scopeName) => {
    const content = await loadGrammarFile(scopeName);
    if (!content)
        return null;
    return parseRawGrammar(content, `${scopeName}.tmLanguage.json`);
};
let onigLib = null;
const loadOnigLib = () => {
    if (onigLib !== null)
        return onigLib;
    return (onigLib = (async () => {
        const { default: wasmRaw } = await import('./onig-f8f1caa4.js');
        const buffer = await wasmRaw();
        await loadWASM(buffer);
        const createOnigScanner = (sources) => new OnigScanner(sources);
        const createOnigString = (str) => new OnigString(str);
        return {
            createOnigScanner,
            createOnigString,
        };
    })());
};
let registry = null;
const getRegistry = async () => {
    if (registry !== null)
        return registry;
    const onigLib = await loadOnigLib();
    return (registry = new Registry({
        onigLib: Promise.resolve(onigLib),
        loadGrammar: loadGrammar,
    }));
};
const lines = (content) => {
    return content.split('\n').map((l) => trimEnd(l));
};
function* tokenizeInner(source, grammar) {
    let ruleStack = INITIAL;
    const scopeStack = [];
    for (const line of lines(source)) {
        const { tokens, ruleStack: nextRuleStack } = grammar.tokenizeLine(line, ruleStack);
        for (const token of tokens) {
            while (scopeStack.length > token.scopes.length ||
                scopeStack[scopeStack.length - 1] !== token.scopes[scopeStack.length - 1]) {
                const scope = scopeStack.pop();
                yield { type: 'end', scope };
            }
            for (const scope of token.scopes.slice(scopeStack.length)) {
                yield { type: 'start', scope };
                scopeStack.push(scope);
            }
            const text = line.substring(token.startIndex, token.endIndex);
            yield { type: 'token', text, scopes: token.scopes };
        }
        ruleStack = nextRuleStack;
        yield { type: 'line' };
    }
    while (scopeStack.length > 0) {
        const scope = scopeStack.pop();
        yield { type: 'end', scope };
    }
}
const tokenize = async (source, lang) => {
    const scopeName = getLang(lang);
    if (!scopeName)
        return null;
    const registry = await getRegistry();
    const grammar = await registry.loadGrammar(scopeName);
    if (!grammar)
        return null;
    return tokenizeInner(source, grammar);
};

export { tokenize };
